{
#
    # 在target_defaults中定义的内容，默认会注入到targets里面，
    # 如果targets中也定义了同样的字段，那么它们会合并。
    'target_defaults': {
        'defines': ['__DEBUG__'],
        'libraries': [
            '<!(pwd)/libs/libjsoncpp_static.a',
            '<!(pwd)/libs/libuv.a',
            '<!(pwd)/libs/libdbus-1.a',
            '-lrt',
        ],

        'cflags': [ '-std=c++11 -Wall -Wno-comment' ],
        'cflags_cc!': ['-fno-exceptions'],

        'conditions':[
            [
                'OS=="mac"', {
                    'defines': ['MAC_OS'],
                    'xcode_settings': {
                        'OTHER_CPLUSPLUSFLAGS' : ['-std=c++11','-stdlib=libc++'],
                        'OTHER_LDFLAGS': ['-stdlib=libc++'],
                    },
                }
            ],
        ]
    },

    'targets':[
         #    {
         #     'target_name': 'sender',
         #     'type': 'executable',
         #     'sources':[
         #         'test/sender.cc',
         #     ],
         #     'include_dirs': [
         #         './dbus_wrap/include/',
         #         './includes/',
         #     ],
         #     'libraries': [
         #        '<!(pwd)/build/Release/bus.a',
         #     ],
         #     'dependencies': [
         #        'libbus',
         #     ],
         # },
        {
            'target_name': 'dbus_wrap',
            'sources': [
                'dbus_wrap/node_binding/DBusProxy.cc',
                'dbus_wrap/node_binding/DBusServer.cc',
                'dbus_wrap/node_binding/dbus_wrap_addon.cc',
            ],
            'dependencies': [ # 多个编译项目时依赖关系
                'libbus',
            ],
            'include_dirs': [
                '<!(node -e \"require(\'nan\')\")',
                './dbus_wrap/node_binding',
                './dbus_wrap/include/',
                './includes/',
                './includes/uv'
            ],
            'libraries': [
                '<!(pwd)/build/Release/bus.a'
            ],
        },
        {
                'target_name': 'libbus',
                'type': 'static_library',
                'sources':[
                    'dbus_wrap/src/DServer.cc',
                    'dbus_wrap/src/DProxy.cc',
                    'dbus_wrap/src/DMessage.cc',
                ],
                'include_dirs': [
                    './dbus_wrap/include/',
                    './includes/',
                ],
        },
         {
             'target_name': 'simulator',
             'type': 'executable',
             'sources':[
                 'tools/Simulator.cc',
                 'tools/SimulatorImpl.cc',
                 'tools/MockDevice.cc',
             ],
             'include_dirs': [
                  './dbus_wrap/include/',
                 './includes/',
                  './tools/',
              ],
              'libraries': [
                 '<!(pwd)/build/Release/bus.a',
              ],
              'dependencies': [
                 'libbus',
              ],
         },
    ]
}
