var DBusProxy = require("../DBusProxy.js");
/**
 * 新建一个Server的代理
 * @param {String} [bus_name] [dbus name]
 * @param {String} [object_path] [object path]
 * @param {String} [interface] [interface]
 * @type {dbus_wrap}
 */

// simulator Proxy
var proxy = new DBusProxy('iot.device.id1024', '/iot/device/id1024','iot.device.id1024');


// server_test proxy
// var proxy = new dbus_wrap.DBusProxy('com.ali.linkedge.server', '/com/ali/linkedge/server','com.ali.linkedge.server');

/**
 * sendSignal('signal_name', param1, param2, param3...)
 * signal_name: 信号名
 * param1, param2...: 参数， 目前只支持Number, Boolean, String 三种类型， 不支持Object
 */
proxy.sendSignal('test_test', 1, false, 'ppp_ddd');
/**
 * callService: 调用Server提供的方法
 * @param  {[type]} 'get'       [method 名字]
 * @param  {[type]} 'property2' [参数1]
 * @param  {[type]} 'value' [参数2]
 * 如果有更多参数，依次列出
 * @param  {[type]} (result     [回调方法，调用对方方法时，获得的结果。 如果方法是void的，
 *                              这个参数可以忽略。 参数列表中只有最后一个Function是回调结果的。]
 */
proxy.callService('get', 'property', 'value', false, (err, result) => {
    if (err) {
        console.log("some error happend: " + err.message);
    }
            // result 是一个String， 内容格式取决于Server的返回格式
    console.log("JS: call get method return: " + result);
});

// call sync method, if error happened, return value is undefined.
var value = { OnOff: "TurnItOff" };
var result = proxy.callServiceSync('set', JSON.stringify(value));
console.log("callServiceSync result: ", result);

// to check after set
proxy.callService('get', 'OnOff', (err, result) => {
    if (err) {
        console.log("2:: some error happend: " + err.message);
    }
    console.log("JS: call get method after set, return: " + result);
});

// var proxy2 = new dbus_wrap.DBusProxy('iot.device.idle2', '/iot/device/idle2', 'iot.device.idle2');
// proxy2.sendSignal('test_test_2', 1, true, 'ppp_222');
// proxy2.callService('get', 'property2', 'value', (result) => {
//             console.log("JS2: call get method return: " + result);
// });
