

const Reset = '\x1b[0m';
const Bright = '\x1b[1m';
const Dim = '\x1b[2m';
const Underscore = '\x1b[4m';
const Blink = '\x1b[5m';
const Reverse = '\x1b[7m';
const Hidden = '\x1b[8m';

const FgBlack = '\x1b[30m';
const FgRed = '\x1b[31m';
const FgGreen = '\x1b[32m';
const FgYellow = '\x1b[33m';
const FgBlue = '\x1b[1;34m';
const FgMagenta = '\x1b[35m';
const FgCyan = '\x1b[36m';
const FgWhite = '\x1b[37m';

const BgBlack = '\x1b[40m';
const BgRed = '\x1b[41m';
const BgGreen = '\x1b[42m';
const BgYellow = '\x1b[43m';
const BgBlue = '\x1b[44m';
const BgMagenta = '\x1b[45m';
const BgCyan = '\x1b[46m';
const BgWhite = '\x1b[47m';

function dateFormat(date, fmt) {
  const o = {
    'M+': date.getMonth() + 1,
    'd+': date.getDate(),
    'H+': date.getHours(),
    'm+': date.getMinutes(),
    's+': date.getSeconds(),
    'S+': date.getMilliseconds(),
  };

  // 因位date.getFullYear()出来的结果是number类型的,所以为了让结果变成字符串型，下面有两种方法：
  if (/(y+)/.test(fmt)) {
    // 第一种：利用字符串连接符“+”给date.getFullYear()+""，加一个空字符串便可以将number类型转换成字符串。
    fmt = fmt.replace(RegExp.$1, (`${date.getFullYear()}`).substr(4 - RegExp.$1.length));
  }

  for (const k in o) {
    if (new RegExp(`(${k})`).test(fmt)) {
      // 第二种：使用String()类型进行强制数据类型转换String(date.getFullYear())，这种更容易理解。
      fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : ((`00${o[k]}`).substr(String(o[k]).length)));
    }
  }

  return fmt;
}
function getDate() {
  return `[${dateFormat(new Date(), 'yyyy-MM-dd HH:mm:ss.S')}]`;
}

module.exports = {
  i(...args) {
    // console.log(FgYellow, '[MOCK::I]', getDate(), ...args, Reset);
  },

  d(...args) {
    // console.log(FgBlue, '[MOCK::D]', getDate(), ...args, Reset);
  },

  e(...args) {
    console.log(FgRed, '[MOCK::E]', getDate(), ...args, Reset);
  },
  /**
   * 给log系统发一个signal，由系统处理这条log
   * @param level log等级
   *           LOG_LEVEL_DEBUG = 0,
   *           LOG_LEVEL_INFO = 1,
   *           LOG_LEVEL_WARN = 2,
   *           LOG_LEVEL_ERR = 3,
   *           LOG_LEVEL_FATAL = 4
   * @param tag TAG
   * @param file 文件名
   * @param func 函数名
   * @param line 文件中的行号
   * @param log log信息
   */
  t(...args) {
    // console.log(FgGreen, '[MOCK::T]', getDate(), ...args, Reset);
  },
};

