const log = require('../../utils/log');
const util = require("util");

module.exports = function(compare, value, checker) {
    var fullfilled = false;
    if (compare === '<') {
        fullfilled = (value < checker);
    } else if (compare === '>') {
        fullfilled = (value > checker);
    } else if (compare === '==') {
        fullfilled = (value === checker);
    } else if (compare === '<=') {
        fullfilled = (value <= checker);
    } else if (compare === '>=') {
        fullfilled = (value >= checker);
    } else if (compare === '!=') {
        fullfilled = (value !== checker);
    } else if (compare === 'in') {
        if (checker && Object.prototype.toString.call(checker) === '[object Array]') {
            for (var i = 0; i < checker.length; i++) {
                if (checker[i] === value) {
                    fullfilled = true;
                    break;
                }
            }
        }
    } else if (compare === 'between') {
        if (checker && Object.prototype.toString.call(checker) === '[object Array]' && checker.length >= 1) {
            fullfilled = (checker[0] <= value && value <= checker[checker.length - 1]);
        }
    } else if (compare === 'like') {
        if (typeof value === 'string' && typeof checker === 'string') {
            fullfilled = value.indexOf(checker) !== -1;
        }
    } else {
        log.i(util.format("[ERROR] compareType '%s' is not supported.", compare));
    }
    return fullfilled;
};
