function parseEvent2StateChangeInfo(event) {
  console.log(event);
  const data = event.data;
  const params = {};
  if (!data.oldState) {
    data.oldState = { attributes: {} };
  }
  if (!data.oldState.attributes) {
    data.oldState.attributes = {};
  }
  if (data.oldState.state !== data.newState.state) {
    params.state = data.newState.state;
  }
  for (const key in data.newState.attributes) {
    if (data.oldState.attributes[key] !== data.newState.attributes[key]) {
      params[key] = data.newState.attributes[key];
    }
  }
  return {
    id: data.entityId,
      params : params
  }
}

module.exports = { parseEvent2StateChangeInfo : parseEvent2StateChangeInfo};