// module cron use 'child_process' to achieve its target,
// it is not full fill our needs.
// var CronJob = require("cron").CronJob;
var nodeSchedule = require("node-schedule");
const log = require('../../utils/log');
const TAG = "IFTTT::TimerTrigger";

var TimerTrigger = function (params, sid, eventBus) {
    this.params = params;
    this.fullfilled = false; // this.fullfilled always set to false, so onPropertiesChanged will nenver triggered it.
    this.trigger = function (info) { } // var it blank,  timer trigger it by itself.
    this.sceneid = sid;
    this.job = undefined;
    this.eventBus = eventBus;
}

TimerTrigger.prototype.start = function () {
    var self = this;
    var cron = this.params["cron"];
    if(!cron || cron === "") {
        log.e(TAG, this.sceneid, "parse 'cron' setting failed, crontab =", cron);
        return null;
    }
    this.job = nodeSchedule.scheduleJob(cron, function() {
        log.i(TAG, 'scene id :', self.sceneid, 'crontab schedule triggered.');
        var trigger = { sceneid: self.sceneid };
        self.eventBus.publish("ifttt_timer_event", trigger);
    });
    if (!this.job) {
        log.e(TAG, this.sceneid, "parse 'cron' setting failed, crontab =", cron);
    }
    return this.job;
};

TimerTrigger.prototype.stop = function () {
    if (this.job) {
        nodeSchedule.cancelJob(this.job);
    }
    return true;
};

TimerTrigger.prototype.eventHappen = function() {
    return false;
};

module.exports = TimerTrigger;
