/**
 * [
            {
                "uri":"trigger/timer",
                "params":{
                    "cron":""
                }
            },
            {
                "uri":"trigger/device/status",
                "params":{
                    "productKey":"",
                    "deviceName":"",
                    "attribute":"",
                    "compareType":"",
                    "compareValue":""
                }
            },
            {
                "uri":"trigger/constant",
                "params":{
                    "expression":""
                }
            }
        ]
 * @param {[type]} trigger [description]
 */
const util = require('util');
const Tag = require('../../utils/constant');
var TimerTrigger = require('./timer_trigger.js');
var DeviceTrigger = require('./device_trigger.js');
var ConstantTrigger = require('./constant_trigger.js');
var EventTrigger = require('./event_trigger.js');
const log = require('../../utils/log');

var Trigger = function(trigger, sid, eventBus, statemachine) {
    if (trigger[Tag.URI] === Tag.DeviceTrigger || trigger[Tag.URI] === Tag.DeviceTrigger1) {
        this.trig = new DeviceTrigger(trigger[Tag.PARAMS], sid, eventBus);
    } else if (trigger[Tag.URI] === Tag.TimerTrigger) {
        this.trig = new TimerTrigger(trigger[Tag.PARAMS], sid, eventBus, statemachine);
    } else if (trigger[Tag.URI] === Tag.ConstTrigger) {
        this.trig = new ConstantTrigger(trigger[Tag.PARAMS], sid, eventBus, statemachine);
    } else if (trigger[Tag.URI] === Tag.EventTrigger) {
        this.trig = new EventTrigger(trigger[Tag.PARAMS], sid, eventBus, statemachine);
    } else {
        log.i("[ERROR] trigger type '" + trigger[Tag.URI] + "' is not supported.");
    }
}

Trigger.prototype.start = function() {
    return this.trig && this.trig.start();
};

Trigger.prototype.stop = function () {
    return this.trig && this.trig.stop();
};

Trigger.prototype.onTrigger = function(info) {
    log.i("Trigger onTrigger: " + JSON.stringify(info));
    return this.trig.trigger(info);
};

Trigger.prototype.eventHappened = function(info) {
    return this.trig.eventHappen(info);
}

Trigger.prototype.isFullFilled = function() {
    return this.trig.fullfilled;
};

module.exports = Trigger;
