'use strict';
//const log = require("logger_wrap.node");
const path = require('path');
const dgram = require('dgram');
const client = dgram.createSocket('udp4');
const port = 12345;
const ip = '127.0.0.1';

class Log {



    /**{
  "content_size":35,
  "pid":0,
  "severity":"INFO",   // typo: serverity to severity
  "function":"function-name",
  "line":0,
  "file":"",
  "content":"FC Invoke End RequestId: request-id",
  "date":"2018-10-11",
  "time":"15:49:05.837",
  "request_id":"requestid",
  "module_name":"FCEdge",
  "sub_module_name":"function-name",
  "version":"1.0",
  "msg_type":"log_msg"
  }**/
    static LOGD() {
        var info = stackInfo();
        var method = info['method'];
        var file = info['file'];
        var line = info['line'];
        var str = "";
        for (var i = 0; i < arguments.length; i++) {
            str += arguments[i] + " ";
        }
        var logInfo = genLineLog("DEBUG", method, line, file, str, "");
        client.send(Buffer.from(logInfo), port, ip);
    }
    static LOGI() {
        var info = stackInfo();
        var method = info['method'];
        var file = info['file'];
        var line = info['line'];
        var str = "";
        for (var i = 0; i < arguments.length; i++) {
            str += arguments[i] + " ";
        }
        var logInfo = genLineLog("INFO", method, line, file, str, "");
        client.send(Buffer.from(logInfo), port, ip);
        // logger.logi(file, method, line, str);
    }
    static LOGE() {
        var info = stackInfo();
        var method = info['method'];
        var file = info['file'];
        var line = info['line'];
        var str = "";
        for (var i = 0; i < arguments.length; i++) {
            str += arguments[i] + " ";
        }
        var logInfo = genLineLog("ERROR", method, line, file, str, "");
        client.send(Buffer.from(logInfo), port, ip);
        // logger.loge(file, method, line, str);
    }
    /*最严重的错误*/
    static LOGF() {
        var info = stackInfo();
        var method = info['method'];
        var file = info['file'];
        var line = info['line'];
        var str = "";
        for (var i = 0; i < arguments.length; i++) {
            str += arguments[i] + " ";
        }
        var logInfo = genLineLog("FATAL", method, line, file, str, "");
        client.send(Buffer.from(logInfo), port, ip);
        // logger.logf(file, method, line, str);
    }
    static LOGM() {
        var info = stackInfo();
        var method = info['method'];
        var file = info['file'];
        var line = info['line'];
        var str = "";
        for (var i = 0; i < arguments.length; i++) {
            str += arguments[i] + " ";
        }
        var logInfo = genLineLog("MILESTONE", method, line, file, str, "");
        client.send(Buffer.from(logInfo), port, ip);
        // logger.logm(file, method, line, str);
    }
    static LOGW() {
        var info = stackInfo();
        var method = info['method'];
        var file = info['file'];
        var line = info['line'];
        var str = "";
        for (var i = 0; i < arguments.length; i++) {
            str += arguments[i] + " ";
        }
        var logInfo = genLineLog("WARNING", method, line, file, str, "");
        client.send(Buffer.from(logInfo), port, ip);
        // logger.logw(file, method, line, str);
    }
}

function stackInfo() {
    var stackReg = /at\s+(.*)\s+\((.*):(\d*):(\d*)\)/i;
    var stackReg2 = /at\s+()(.*):(\d*):(\d*)/i;
    var stacklist = (new Error()).stack.split('\n').slice(3);
    var s = stacklist[0];
    var sp = stackReg.exec(s) || stackReg2.exec(s);
    var data = {};
    if (sp && sp.length === 5) {
        data.method = sp[1];
        data.path = sp[2];
        data.line = parseInt(sp[3]);
        data.pos = sp[4];
        data.file = path.basename(data.path);
    }
    return data;
}

function genLineLog(severity, functionName, line, file, content, sub_module_name) {
    var log = {};
    log.content_size = 0;
    log.module_name = "ifttt";
    log.pid = process.pid;
    log.severity = severity;
    log.function = functionName;
    log.line = line;
    log.file = file;
    log.content = content;
    log.data = new Date().Format("yyyy-MM-dd");
    log.time = new Date().Format("HH:mm:ss:SS");
    log.request_id = "requestid";
    log.sub_module_name = sub_module_name;
    log.version = "1.0";
    log.msg_type = "log_msg";
    return JSON.stringify(log);
}

module.exports = Log;
