/*
 * Copyright (c) 2018 Alibaba Group Holding Ltd. All rights reserved.
 */

exports.buildArnString = function (region, accountId, serviceName, functionName) {
  var regionString = region === undefined || region === null ? '' : region;
  var accountIdString = accountId === undefined || accountId === null ? '' : accountId;

  if (serviceName === undefined || serviceName === null || serviceName === '') {
    throw new Error(`Can't build arn string with illegal "serviceName": ${serviceName}.`);
  }

  if (functionName === undefined || functionName === null || functionName === '') {
    throw new Error(`Can't build arn string with illegal "functionName": ${functionName}.`);
  }
  return `acs:fc:${regionString}:${accountIdString}:service:${serviceName}:function:${functionName}`;
};